var StockResearch = StockResearch || {};

StockResearch.toggleToolbar = function(event){
	var toolbar = document.getElementById("stock-research-toolbar");
    toolbar.collapsed = !toolbar.collapsed;
    document.persist("stock-research-toolbar", "collapsed");
};

StockResearch.open = function(url){
	gBrowser.selectedTab = gBrowser.addTab(url);
};
StockResearch.ticker = function(){
	return document.getElementById("stock-research-ticker").value.trim();
};


StockResearch.go = function(where){
	if(this.ticker() == "" || this.ticker() == "Ticker"){
		return;
	}
	where = where.replace('stock-research-', '');
	switch (where){
		// quote pages
		case "google":
			this.open("http://www.google.com/finance?q=" + this.ticker());
			break;
		case "morningstar":
			this.open("http://quote.morningstar.com/stock/s.aspx?t=" + this.ticker());
			break;
		case "seekingalpha":
			this.open("http://seekingalpha.com/symbol/" + this.ticker() + "/");
			break;
		case "reuters":
			this.open("http://www.reuters.com/finance/stocks/financialHighlights?symbol=" + this.ticker());
			break;
		case "yahoo":
			this.open("http://finance.yahoo.com/q?s=" + this.ticker());
			break;
		case "stocktwits":
			this.open("http://stocktwits.com/symbol/" + this.ticker());
			break;
		case "msn":
			this.open("http://investing.money.msn.com/investments/stock-price?Symbol=" + this.ticker());
			break;
		case "bloomberg":
			this.open("http://www.bloomberg.com/quote/" + this.ticker() + ":us");
			break;
		case "bloombergbusinessweek":
			this.open("http://investing.businessweek.com/research/stocks/snapshot/snapshot.asp?ticker=" + this.ticker());
			break;
			
		// profile ##################################
		case "profile-reuters":
			this.open("http://www.reuters.com/finance/stocks/companyProfile?symbol=" + this.ticker());
			break;
		case "profile-yahoo":
			this.open("http://finance.yahoo.com/q/pr?s=" + this.ticker());
			break;
		case "profile-msn":
			this.open("http://investing.money.msn.com/investments/company-report?symbol=" + this.ticker());
			break;
		case "profile-marketwatch":
			this.open("http://www.marketwatch.com/investing/stock/" + this.ticker() + "/profile");
			break;
			
		// charts ##################################
		case "chart-stockcharts":
			this.open("http://stockcharts.com/h-sc/ui?s=" + this.ticker() + "&p=D&b=5&g=0&id=p74753813418");
			break;
		case "chart-yahoo":
			this.open("http://finance.yahoo.com/q/bc?s=" + this.ticker());
			break;
		case "chart-yahoo-inter":
			this.open("http://finance.yahoo.com/echarts?s=" + this.ticker());
			break;
		case "chart-msn":
			this.open("http://investing.money.msn.com/investments/charts/?symbol=" + this.ticker());
			break;
		case "chart-morningstar":
			this.open("http://quote.morningstar.com/stock/chart.aspx?t=" + this.ticker());
			break;
			
		// options ##################################
		case "options-yahoo":
			this.open("http://finance.yahoo.com/q/op?s=" + this.ticker());
			break;
		case "options-google":
			this.open("http://www.google.com/finance/option_chain?q=" + this.ticker());
			break;
			
		// news ##################################
		case "news-bloomberg":
			this.open("http://www.bloomberg.com/quote/" + this.ticker() + ":US/news/");
			break;
		case "news-reuters":
			this.open("http://www.reuters.com/finance/stocks/companyNews?symbol=" + this.ticker());
			break;
		case "news-reuters-kd":
			this.open("http://www.reuters.com/finance/stocks/" + this.ticker() + "/key-developments");
			break;
		case "news-google":
			this.open("http://www.google.com/finance/company_news?q=" + this.ticker());
			break;
		case "news-yahoo":
			this.open("http://finance.yahoo.com/q/h?s=" + this.ticker());
			break;
		case "news-sec":
			this.open("http://www.sec.gov/cgi-bin/browse-edgar?CIK=" + this.ticker() + "&owner=exclude&action=getcompany&type=8");
			break;
		// insiders ##################################
		case "insiders-businessweek":
			this.open("http://investing.businessweek.com/research/stocks/people/people.asp?ticker=" + this.ticker());
			break;
		case "insiders-morningstar":
			this.open("http://insiders.morningstar.com/trading/executive-compensation.action?t=" + this.ticker());
			break;
		case "insiders-yahoo":
			this.open("http://finance.yahoo.com/q/it?s=" + this.ticker());
			break;
		case "insiders-reuters":
			this.open("http://www.reuters.com/finance/stocks/companyOfficers?symbol=" + this.ticker());
			break;
		case "insiders-reuters-trades":
			this.open("http://www.reuters.com/finance/stocks/insiderTrading?symbol=" + this.ticker());
			break;
		// ownership ##################################
		case "owners-morningstar":
			this.open("http://investors.morningstar.com/ownership/shareholders-overview.html?t=" + this.ticker());
			break;
		case "owners-msn":
			this.open("http://investing.money.msn.com/investments/institutional-ownership?symbol=" + this.ticker());
			break;
		case "owners-whalewisdom":
			this.open("http://whalewisdom.com/stock/" + this.ticker());
			break;
		// transcripts ##################################
		case "transcripts-seekingalpha":
			this.open("http://seekingalpha.com/symbol/" + this.ticker() + "/transcripts");
			break;
		case "transcripts-morningstar":
			this.open("http://www.morningstar.com/earnings/earnings-call-transcript.aspx?t=" + this.ticker());
			break;
		// analysts ##################################
		case "analysts-reuters":
			this.open("http://www.reuters.com/finance/stocks/analyst?symbol=" + this.ticker());
			break;
		case "analysts-marketwatch":
			this.open("http://www.marketwatch.com/investing/stock/" + this.ticker() + "/analystestimates");
			break;
		case "analysts-msn":
			this.open("http://investing.money.msn.com/investments/analyst-ratings/?symbol=" + this.ticker());
			break;
		case "analysts-msn-earnings":
			this.open("http://investing.money.msn.com/investments/earnings-estimates?symbol=" + this.ticker());
			break;
		case "analysts-estimize":
			this.open("http://www.estimize.com/" + this.ticker());
			break;
		// ratios ##################################
		case "ratios-reuters":
			this.open("http://www.reuters.com/finance/stocks/financialHighlights?symbol=" + this.ticker());
			break;
		case "ratios-businessweek":
			this.open("http://investing.businessweek.com/research/stocks/financials/ratios.asp?ticker=" + this.ticker());
			break;
		case "ratios-yahoo":
			this.open("http://finance.yahoo.com/q/ks?s=" + this.ticker());
			break;
		case "ratios-msn":
			this.open("http://investing.money.msn.com/investments/key-ratios?symbol=" + this.ticker() + "&page=TenYearSummary");
			break;
		case "ratios-msn-stats":
			this.open("http://investing.money.msn.com/investments/financial-statements?symbol=" + this.ticker());
			break;
		case "ratios-morningstar":
			this.open("http://financials.morningstar.com/ratios/r.html?t=" + this.ticker());
			break;
		// financials ##################################
		case "financials-morningstar":
			this.open("http://financials.morningstar.com/income-statement/is.html?t=" + this.ticker());
			break;
		case "financials-marketwatch":
			this.open("http://www.marketwatch.com/investing/stock/" + this.ticker() + "/financials");
			break;
		case "financials-businessweek":
			this.open("http://investing.businessweek.com/research/stocks/financials/financials.asp?ticker=" + this.ticker());
			break;
		case "financials-google":
			this.open("http://www.google.com/finance?q=" + this.ticker() + "&fstype=ii");
			break;
		// price data ##################################
		case "hprice-yahoo":
			this.open("http://finance.yahoo.com/q/hp?s=" + this.ticker());
			break;
		case "hprice-google":
			this.open("http://www.google.com/finance/historical?q=" + this.ticker());
			break;
		case "hprice-msn":
			this.open("http://investing.money.msn.com/investments/equity-historical-price/?symbol=" + this.ticker());
			break;
		// web ratings ##################################
		case "ratings-caps":
			this.open("http://www.fool.com/quote/jump?ticker-input=" + this.ticker());
			break;
		case "ratings-msn":
			this.open("http://investing.money.msn.com/investments/stock-ratings/?symbol=" + this.ticker());
			break;
		case "ratings-vectorgrader":
			this.open("http://www.vectorgrader.com/stockRank/" + this.ticker());
			break;
		case "ratings-validea":
			this.open("http://www.nasdaq.com/symbol/" + this.ticker() + "/guru-analysis");
			break;
		case "other-sec":
			this.open("http://www.sec.gov/cgi-bin/browse-edgar?CIK=" + this.ticker() + "&owner=exclude&action=getcompany");
			break;
		case "other-transactions":
			this.open("http://investing.businessweek.com/research/stocks/transactions/transactions.asp?ticker=" + this.ticker());
			break;
		case "other-bonds":
			this.open("http://quicktake.morningstar.com/StockNet/bonds.aspx?Symbol=" + this.ticker());
			break;
		case "other-pension":
			this.open("http://investing.businessweek.com/research/stocks/financials/pensions.asp?ticker=" + this.ticker());
			break;
	}
};

// opens a menu when hoverd over if a sibling menu is already open and closes the sibling menu
StockResearch.openToolbarButton = function(newTbarButton){

	// if new toolbar is set and is closed
	if(newTbarButton && newTbarButton.open == false){
		var tBarButton  = null;
		var tBarButtons = newTbarButton.parentNode.getElementsByTagName("toolbarbutton");

		// see if there is another sibling toolbarbutton already open
		for(var i = 0, len = tBarButtons.length; i < len; i++){
			tBarButton = tBarButtons.item(i);

			// if the toolbar button exists, is not the current one, and is open
			if(tBarButton && tBarButton != newTbarButton && tBarButton.open == true){
				tBarButton.open = false;
				newTbarButton.open = true;
				break;
			}
		}
	}
};

